/*

Here is a simple but good working random number generator for with a
period of 2^31-2. It generates uniformly distributed numbers in the
range from 0 to 1, limits included.

Clipper code donated to the Public Domain by Phil Barnett November 29, 1996

Random numbers donated to the Universe by God.

*/

static seed := 0

/*
procedure test()

local d := date()
local x

SET DECIMAL TO 16

// call it once with the seed
random( seconds() * day( d ) * month( d ) * year( d )  )

do while !lastkey() == 27

   // then, call it with no parameter repeatedly
   x := random()
   ? x

   // produces random numbers in the range of 0 - 100 inclusive
   ?? int( x * ( 100 + 1 ) )

   // produces random numbers in the range of 1 - 100 inclusive
   ?? int( x * 100 ) + 1

   // produces random numbers in the range of 0 - 99 inclusive
   ?? int( x * 100 )

   // inkey(.01)

enddo

return
*/

********************************************************************

function random( s )

local a := 16807 // This is just a lucky prime number

// you can hardcode these as constants for better speed
local m := ( 2 ^ 31 ) - 1
local q := int( m / a )
local r := int( m % a )

if valtype( s ) == 'N'
   seed := s
endif

seed := a * ( seed % q ) - r * ( seed / q )

IF seed <= 0
   seed += m
endif

return ( seed - 1 ) / ( m - 2 )

/*
Other Prime Numbers are:

38833
37171
11903
18233
31337
23339
27481
31063
34543  // an anagram prime!
36299
13691
17659
29411

If you need more, get the SIEVE.ZIP program and modify it.

*/
