/*

Newsgroups: comp.lang.clipper
From: awhite@user.rose.com (Allen White)
Subject: Re: True Random numbers

Try this little function:

*/

/*
  Name: Rand.prg
  By  : Allen White
  Date: 24 Feb 92
  Use : Generate a random number between 0 and 1
*/

#define PRIME 335544319

Function Random( nSeed )

static nLastRandom

local nMultiplier := int( seconds() )

if valtype( nSeed ) == "N"
  nLastRandom := nSeed
endif

if valtype( nLastRandom ) != "N"
  nLastRandom := ( nMultiplier * ;
                   ( ( seconds() - int( seconds() ) ) * 100 ) ) % PRIME
endif

nLastRandom := ( nMultiplier * nLastRandom ) % PRIME

return nLastRandom / PRIME

